//This class draws the main map in the configuration frame

//imported classes
import java.awt.Graphics;
import javax.swing.JPanel;
import java.awt.Color;
import java.awt.Point;


public class MapPanel extends JPanel 
{
	
	
	Point peerPositions[] = new Point[8]; //stores the peer positions in Points (x,y)
	
	char pID[] = {'M','1','2','3','4','5','6','7'};
	
	int rangesMatrix[] = new int[8];
	
	boolean sR = false;

	
	public MapPanel()
	{
		for (int i = 0 ; i < peerPositions.length ; i++)
		{
			peerPositions[i] = new Point(0,0);
			rangesMatrix[i] = 100;		
		}
			
			
	
	}
	
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);
		
		int width = getWidth();
		int height = getHeight();
		
		this.setBackground(Color.WHITE);
		g.setColor(Color.BLUE);
		
		for (int i=0;i<=width;i+=15)
		{
			g.drawLine(i,0,i,height);
		}
		
		for (int x=0;x<=height;x+=15)
		{
			g.drawLine(0,x,width,x);
		}
		
		for (int i = 0 ; i < peerPositions.length ; i++	)
		{
			if ((peerPositions[i].x != 0) && (peerPositions[i].y != 0))
			{
				if (i==0) g.setColor(Color.RED);
				else if (i != 0 ) g.setColor(Color.YELLOW);
				g.fillOval(peerPositions[i].x-10,peerPositions[i].y-10,20,20);				
				g.setColor(Color.BLACK);
				g.drawOval(peerPositions[i].x-10,peerPositions[i].y-10,19,19);				
				g.drawChars(pID,i,1,(peerPositions[i].x-4),(peerPositions[i].y+5));				
			}
		}
		
		for (int i = 0 ; i < peerPositions.length ; i++	)
		{
			if ((sR) && (peerPositions[i].x != 0) && (peerPositions[i].y != 0))
			{
				g.drawOval(peerPositions[i].x-(rangesMatrix[i]),peerPositions[i].y-(rangesMatrix[i]),(2*rangesMatrix[i]),(2*rangesMatrix[i]));
			}
		}
		
	} //end of paintComponent
	
	public void setPeer(Point p , byte i)
	{
		peerPositions[i]=p;
	}
	
	public void removeSlaves(byte newSlavesNum)
	{
		for ( int i = (newSlavesNum+1) ; i < peerPositions.length ;i++)
		{
			peerPositions[i].x=0;
			peerPositions[i].y=0;
		}
	}
	
	public void showRanges(boolean sr)
	{
		sR = sr;
	}
	
	public void copyRangesMatrix(int[] r)
	{
		for ( int i = 0 ; i < rangesMatrix.length ; i++)
		{
			rangesMatrix[i] = r[i];			
		}
	}
}