import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;
import java.util.concurrent.locks.Condition;
import java.util.Random;
import javax.swing.JOptionPane;
import java.awt.Color;
import java.util.Calendar;



public class Peer implements Runnable
{
	
	
	Simulation simulation;
	ThreadHandler handler;
	SimClock simClock;
	
	private String BDUID;
	private byte Range;
	private byte AMA;
	private int PMA;
	private float x_position,
		  		  y_position;
	private int Clock;
	private boolean acl;
	public boolean master;
	private enum Status { STAND_BY, INQUIRY , PAGE, CONNECTED , PARK , HOLD , SNIFF };
	private Status currentStatus;
	
	public int peerNum;	
	
	private static Random generator = new Random();
	
	public boolean[] peersInRange = new boolean[7];
	boolean[] polling = new boolean[8];
	
	int peersInquired =0;
	int peersPaged = 0;
	boolean masterInRange = false;
	boolean connected = false;
	boolean runs = true;
	int timeLimit = 0;
	int runMode = 0;
	
	int mode = 1;
	
	private float Z;
	private float R;
	private float B;
	private float N;
	private int Q = 1000;
	
	Packet buffer[];;
	boolean readyToTransmit = false;
	boolean packetSend = false;
	
	
	PeerStats peerStats;
	Storage store;
	
	int index = 0;
	int peerSlotShare = 0;
	int polled = 0;
	
	int totalPackets = 0;
	int totalBytes = 0;
	int packetsLost = 0;
	int packetsCreated = 0;
	int totalWaitingTime = 0;
	int delay = 0;
	private Calendar now;


	//Constructor
	public Peer(int p,Simulation sim, ThreadHandler threadHandler,Storage st)
	{
		peerNum = p;
		simulation = sim ;
		handler = threadHandler;
		store = st;
		R = store.getR();
		Z = store.getZ();
		B = store.getB();
		Q = store.getQ();
		//N = store.getPeerNum();
		buffer = new Packet[Q];
		for (int i = 0 ; i <buffer.length ; i++) buffer[i] = new Packet("zero");
		peerStats = new PeerStats(this);
		
		
	}
	
	public Peer(int p,Simulation sim, ThreadHandler threadHandler,int tL,SimClock sC,Storage st)
	{
		peerNum = p;
		simulation = sim ;
		handler = threadHandler;
		timeLimit = tL;
		runMode = 1;
		simClock = sC;
		store = st;
		R = store.getR();
		Z = store.getZ();
		B = store.getB();
		Q = store.getQ();
		//N = store.getPeerNum();
		buffer = new Packet[Q];	
		for (int i = 0 ; i <buffer.length ; i++) buffer[i] = new Packet("zero");
		peerStats = new PeerStats(this);		
		
	}
	
	
	public void run()
	{
	
			//System.out.println("Curent Minute :"+simulation.getTimeLimit()+" Timelimit:"+timeLimit);
			try
			{
				Thread.sleep(generator.nextInt(3000));
				
				if (peerNum == 0)
				{
					simulation.setPeerStatus(peerNum,1);
					peerStats.setStatus(1);
					if (!simulation.checkPeersInRange(this))
					{
						JOptionPane.showMessageDialog(null,"No Slaves are in range with the Master.Simulation Aborted!","Simulation Error!",JOptionPane.ERROR_MESSAGE);
					}
					else 
					{
						while(peersInquired<numPeersInRange())
						{
							Thread.sleep(generator.nextInt(2000));
							//System.out.println("Master is sleeping!");
							//System.out.println("peersInquired="+peersInquired+"\tnumPeersInRange="+numPeersInRange());
						}
							
						simulation.setPeerStatus(peerNum,3);
						peerStats.setStatus(3);
					
						while(peersPaged<numPeersInRange())
						{
							Thread.sleep(generator.nextInt(2000));
							//System.out.println("Master is sleeping!");
						}						
						simulation.setPeerStatus(peerNum,5);
						peerStats.setStatus(5);	
						setAllConnected();
						//ValuesFrame values = new ValuesFrame(R,Z,B,Q,store.getPeerNum());
						
						while  (runs)
						{
							peerStats.setBufferStatus((int)(((float)index/(float)Q)*100));							
							if (mode==1)
							{
								peerStats.setMode(1);							
								if (index<Q)
								{
									for (int i=0 ; i<4 ; i++)
									{
										//Thread.sleep(1);
										Packet tempPacket = new Packet();										
										buffer[index++] = tempPacket;
										packetsCreated++;
										peerStats.setBufferStatus((int)(((float)index/(float)Q)*100));										
									
									}
									
									//System.out.println("I am peer #"+peerNum+" and my buffer is "+(index/1000)+"% full. Packets transmitted so far :"+totalPackets);
								}
								else 
								{
									packetsLost++;
									peerStats.setPacketsLost(packetsLost);
									peerStats.setPercentLost((float)packetsLost/(float)packetsCreated);
								}
								
								if ( generator.nextInt((int)(B)) ==((int)(B/2))) {this.mode=0;
																					//System.out.println("\n\n\n\n\n\t\t\t\t\tPeer "+peerNum+" STATE CHANGE ("+mode+")\n\n\n\n\n");
																				}
																
							}
							else
							{
								peerStats.setMode(0);
								N = (store.getPeerNum()+1);
								int temp = generator.nextInt((int)(B*(N*Z-R)*10));
								if ((temp > (((int)((B*(N*Z-R)/2)*10))-((R*10/2)-1))) && (temp < (((int)((B*(N*Z-R)/2)*10))+(R*10/2)))) {this.mode=1;//System.out.println("\n\n\n\n\n\t\t\t\t\tPeer "+peerNum+" STATE CHANGE ("+mode+")\n\n\n\n\n");
																																		}
							}
							
							if ((readyToTransmit) && (index>0))
							{
								packetSend = false;
								for (int i=0 ; i<4 ; i++) send(buffer[i]);
								if (packetSend)
								{
									for ( int i = 0 ; i<buffer.length-4 ; i++ )
									{
										buffer[i] = buffer[i+4];									
									}
								index-=4;								
								}
								
								readyToTransmit = false;
								//Thread.sleep(4);
							}
							else Thread.sleep(2);
							peerStats.repaint();
							Thread.sleep(4);							
							
							polled = 0;
							for (int i = 0 ; i<peersInRange.length ; i++)
							{
								if (peersInRange[i]) {polling[i+1] = simulation.checkIfPeerWantsToTransmit(i+1);}
								if (polling[i+1]) 
								{
									polled++;
									//System.out.println("Peer "+(i+1)+" wants to transmit!!!!!!!!!!!!!!!!!!!!!Poled="+polled);
								}
							}				
							if (this.index>0) 
							{
								polling[0] = true;
								polled++;
							}
							if (polled>0)
							{
								peerSlotShare = 200/polled;
								//System.out.println("*~*~*~*~peerSlotShare = "+peerSlotShare);
								for (int i = 0 ; i<peerSlotShare ; i++)
								{
									for (int z = 0 ; z<polling.length ; z++)
									{
										if (polling[z]) {simulation.orderTransmission(z);
														//System.out.println("zzzzzzzzzzzzzzzPeer "+(z+1)+" was ordered to transmit");
														}
										//Thread.sleep(1);
									}								
								}
							}
							//else Thread.sleep(50);						
							if (runMode == 1)
							{
								if (timeLimit == simClock.getCurrentMinute()) simulation.timesUp();
							}
						
						}//end while(runs)
						
					}//end if at least one peer in range
								
				} //end if (peerNum = 0)
			
				else
				{
					simulation.setPeerStatus(peerNum,2);
					peerStats.setStatus(2);
					peerStats.repaint();
					if (simulation.checkMasterInRange(this))
					{
						Thread.sleep(generator.nextInt(5000));
						simulation.setInquired();
						simulation.setPeerStatus(peerNum,4);
						peerStats.setStatus(4);
						peerStats.repaint();
						Thread.sleep(generator.nextInt(2000));
						simulation.setPaged();
						while (!connected) Thread.sleep(300);
						peerStats.setStatus(5);
						peerStats.repaint();
						while (runs)
						{
							peerStats.setBufferStatus((int)(((float)index/(float)Q)*100));
							if (mode==1)
							{
								peerStats.setMode(1);							
								if (index<Q)
								{
									for (int i=0 ; i<4 ; i++)
									{
										Thread.sleep(1);
										Packet tempPacket = new Packet();										
										buffer[index++] = tempPacket;
										packetsCreated++;
									
									}
									
									//System.out.println("I am peer #"+peerNum+" and my buffer is "+(index/1000)+"% full. Packets transmitted so far :"+totalPackets);
								}
								else 
								{
									packetsLost++;
									peerStats.setPacketsLost(packetsLost);
									peerStats.setPercentLost((float)packetsLost/(float)packetsCreated);
								}
								
								if ( generator.nextInt((int)(B)) ==((int)(B/2))) {this.mode=0;
																					//System.out.println("\n\n\n\n\n\t\t\t\t\tPeer "+peerNum+" STATE CHANGE ("+mode+")\n\n\n\n\n");
																				}
																
							}
							else
							{
								peerStats.setMode(0);
								N = (store.getPeerNum()+1);
								int temp = generator.nextInt((int)(B*(N*Z-R)*10));
								if ((temp > (((int)((B*(N*Z-R)/2)*10))-((R*10/2)-1))) && (temp < (((int)((B*(N*Z-R)/2)*10))+(R*10/2)))) {this.mode=1;//System.out.println("\n\n\n\n\n\t\t\t\t\tPeer "+peerNum+" STATE CHANGE ("+mode+")\n\n\n\n\n");
																																		}
							}
							
							if ((readyToTransmit) && (index>0))
							{
								packetSend = false;
								for (int i=0 ; i<4 ; i++) send(buffer[i]);
								if (packetSend)
								{
									for ( int i = 0 ; i<buffer.length-4 ; i++ )
									{
										buffer[i] = buffer[i+4];									
									}
								index-=4;								
								}
								
								readyToTransmit = false;
							}
							else Thread.sleep(2);
							peerStats.repaint();
							Thread.sleep(4);
							
						}
						
						
					}	
					else
					{					
						Thread.sleep(5000);
						simulation.setPeerStatus(peerNum,2);
						Thread.sleep(generator.nextInt(3000));
						simulation.setColor(Color.LIGHT_GRAY,peerNum);
						simulation.setPeerStatus(peerNum,0);
						peerStats.setStatus(0);					
					}
				} //end else (peerNum != 0)
			}
			catch (InterruptedException exception)
			{
				exception.printStackTrace();
			}
			
		
	} //end of run


	public void setPeerInRange(int i)
	{
		peersInRange[i-1] = true;
	}
	
	public void incPeersInquired()
	{
		//System.out.println("Before:"+this.peersInquired);
		this.peersInquired++;
		//System.out.println("After:"+this.peersInquired);
	}
	
	public void incPeersPaged()
	{
		peersPaged++;
	}
	
	public void setAllConnected()
	{
		for (int i = 0 ; i<peersInRange.length ; i++)
		{
			if (peersInRange[i])
			{
				simulation.setPeerStatus(i+1,5);
				simulation.setConnected(i+1);
			}
			
		}
	}
	
	public void setMasterInRange()
	{
		masterInRange = true;
	}
	
	public int getPeerNum()
	{
		return peerNum;
	}
	
	public int numPeersInRange()
	{
		int temp =0;
		for (int i = 0 ; i<peersInRange.length ; i++)
		{
			if (peersInRange[i]) temp++;
		}
		simulation.setN(temp);
		
		return temp;
		
	}



	public void pause()
	{
		handler.pause();
	}
	
	public void setConnected()
	{
		this.connected = true;
	}
	
	public boolean bufferEmpty()
	{
		if (this.index>0) return false;
			else return true;
	}
		
	public void okToTransmit()
	{
		readyToTransmit = true;
	}
	
	private void send(Packet packet)
	{
		
		if (isPacketOk(packet.getSize())) 
		{
			simulation.drawPacket(peerNum);
			totalPackets++;
			totalBytes +=packet.getSize();
			now = Calendar.getInstance();
			int transmissionTime = (now.get(Calendar.HOUR_OF_DAY)*3600000)+(now.get(Calendar.MINUTE)*60000)+(now.get(Calendar.SECOND)*1000)+now.get(Calendar.MILLISECOND);
			//System.out.println("birthtime:"+packet.getBirthDate()+"\ttransmission:"+transmissionTime);
			totalWaitingTime+= transmissionTime - packet.getBirthDate();			
			delay = totalWaitingTime/totalPackets;
			peerStats.setPacketsSend(totalPackets);
			peerStats.setBytesSend(totalBytes);
			peerStats.setDelay(delay);
			packetSend = true;
			//System.out.println("*******I TRANSMIT*********peer :"+peerNum+"\tIndex is:"+index);
		}
		
		else
		{
			packetsLost++;
			peerStats.setPacketsLost(packetsLost);
			peerStats.setPercentLost((float)packetsLost/(float)packetsCreated);
			packetSend = false; 
			//System.out.println("*TRANSMISSION ERROR**peer :"+peerNum+"\tIndex is:"+index);
		}
		
		
	}
	
	private boolean isPacketOk(int s)
	{
		
		int power = getBER();
		double probability = (1-Math.pow(10,-power));
		//System.out.println("power : "+power+"\tprobability : "+probability+"\ttotal bits :"+(s*8));
		probability = Math.pow(probability,(s*8));
		/*for (int i = 0 ; i < (s*8) ; i++)
		{
			probability*=probability;
			System.out.println("TEMP probability : "+probability);
		}*/
		//System.out.print("FINAL probability : "+probability);
		probability*=100d;
		//System.out.println("\\FINAL probability after : "+probability);
		int correct = (int)probability;
		int temp = generator.nextInt(101);
		//System.out.println("correct : "+correct+"\ttemp : "+temp+"\t"  );
		if (((temp) > (50 - (probability/2))) && (temp < (50 + (probability/2)))) return true;
		else return false;
		
		
	}
	
	private int getBER()
	{
		float temp = simulation.calculateDistance(peerNum);
		if (temp <= 20) return 8;
		else if ((temp>20) && (temp<=80)) return 6;
		else return 4;
		//return 6
	}
	
	public void showStats()
	{
		peerStats.setVisible(true);
	}
	
	public int getDelay()
	{
		return delay;
	}
	
	public int getBytes()
	{
		return totalBytes;
	}
	
	/*
	public void pause()
	{
		this.accessLock.lock();
		try
		{
			this.running.await();
		}
		catch (InterruptedException exception)
		{
			exception.printStackTrace();
		}
		catch (Exception exception)
		{
			exception.printStackTrace();
		}
		finally
		{
			this.accessLock.unlock();
		}
		
	}
	
	public void resume()
	{
		this.accessLock.lock();
		//try
		//{
			this.running.signal();
		//}
	//	catch (InterruptedException exception)
	//	{
		//	exception.printStackTrace();
	//	}
	
		this.accessLock.unlock();
	}
	*/
	public void stop()
	{
		runs = false;
	}
	
	public void reset()
	{
		simulation.setPeerStatus(peerNum,0);
	}
			
}