import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.Float;
import java.lang.Character;
import java.lang.*;

public class PeerStats extends JFrame implements ActionListener
{
	JPanel informationPanel = new JPanel(new GridLayout(8,2));
	
	
	JLabel title;
	JLabel statusTitle =       new JLabel("Status                    :",JLabel.LEFT);
	JLabel packetsSendTitle  = new JLabel("Packets send        :",JLabel.LEFT);
	JLabel bytesSendTitle    = new JLabel("Bytes send             :",JLabel.LEFT);
	JLabel packetsLostTitle  = new JLabel("Packets lost         :",JLabel.LEFT);
	JLabel percentLostTitle  = new JLabel("Percent lost         :",JLabel.LEFT);
	JLabel delayTitle  = new JLabel("Average Delay         :",JLabel.LEFT);
	JLabel bufferStatusTitle = new JLabel("Buffer used           :",JLabel.LEFT);
	JLabel modeTitle         = new JLabel("Generation mode :",JLabel.LEFT);
	
	
	JLabel status =       new JLabel("-",JLabel.CENTER);
	JLabel packetsSend  = new JLabel("-",JLabel.CENTER);
	JLabel bytesSend    = new JLabel("-",JLabel.CENTER);
	JLabel packetsLost  = new JLabel("-",JLabel.CENTER);
	JLabel percentLost  = new JLabel("-",JLabel.CENTER);
	JLabel delay        = new JLabel("-",JLabel.CENTER);
	JLabel bufferStatus = new JLabel("-",JLabel.CENTER);
	JLabel mode         = new JLabel("-",JLabel.CENTER);
	
	JButton closeButton = new JButton("Close");
	
	String[] statusText = {"Stand By","Inquiring","Inquiry Scan","Paging","Page Scan","Connected","Hold","Park","Sniff"};
	
	Peer peer;
	
	
	public PeerStats(Peer p)
	{
		super("Peer "+p.getPeerNum());
		peer = p;
		if (p.getPeerNum()==0) title = new JLabel("Master Statistics\n",JLabel.CENTER);
		else title = new JLabel("Peer "+peer.getPeerNum()+" Statistics\n",JLabel.CENTER);
		this.add(title,BorderLayout.NORTH);
		informationPanel.add(statusTitle);
		informationPanel.add(status);
		informationPanel.add(packetsSendTitle);
		informationPanel.add(packetsSend);
		informationPanel.add(bytesSendTitle);
		informationPanel.add(bytesSend);
		informationPanel.add(packetsLostTitle);
		packetsLost.setForeground(Color.RED);
		informationPanel.add(packetsLost);
		informationPanel.add(percentLostTitle);
		percentLost.setForeground(Color.RED);
		informationPanel.add(percentLost);
		informationPanel.add(delayTitle);
		informationPanel.add(delay);
		informationPanel.add(bufferStatusTitle);
		informationPanel.add(bufferStatus);
		informationPanel.add(modeTitle);
		mode.setForeground(Color.DARK_GRAY);
		informationPanel.add(mode);
		this.add(informationPanel,BorderLayout.CENTER);
		this.add(closeButton,BorderLayout.SOUTH);
		closeButton.addActionListener(this);
		this.setLocation(891,(peer.getPeerNum()%4)*175);
		this.setSize(230,175);
		this.setEnabled(true);
		this.setResizable(false);
		this.setVisible(false);
		
		
	}
	
	public void setStatus(int s)
	{
		status.setText(statusText[s]);	
	}
	
	public void setPacketsSend(int ps)
	{
		packetsSend.setText(""+ps);
	}
	
	public void setBytesSend(int bs)
	{
		bytesSend.setText(""+bs);		
	}
	
	public void setPacketsLost(int pl)
	{
		packetsLost.setText(""+pl);		
	}
	
	public void setPercentLost(float pl)
	{
		percentLost.setText(String.format("%3.3f%%",(pl*100f)));		
	}
	
	public void setDelay(int d)
	{
		delay.setText(String.format("%6d ms",d));		
	}
	
	public void setBufferStatus(int bs)
	{
		bufferStatus.setText(""+bs+"%");		
	}
	
	public void setMode(int m)
	{
		
		if (m==0)
		{
			mode.setForeground(Color.DARK_GRAY);
			mode.setText("IDLE");
		}
		else
		{
			mode.setForeground(Color.MAGENTA);
			mode.setText("BURSTY");
		}		
	}
	
	public void actionPerformed (ActionEvent ae)
	{
		if ( ae.getSource() == closeButton )
		{
			this.setVisible(false);			
		}
	}	
	
}