import java.awt.Graphics;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JLabel;
import java.awt.Color;
import java.awt.Point;
import java.awt.GridLayout;


public class PositionsPanel extends JFrame
{
	GridLayout grid = new GridLayout(9,1);
	
	JPanel panel = new JPanel(grid);
	
	JLabel slaveNames[] = new JLabel[7];
	JLabel master = new JLabel(" MASTER  : ( - , - )",JLabel.CENTER);
	JLabel headline = new JLabel("Peer #  :  ( X , Y )",JLabel.CENTER);
	
	public PositionsPanel()
	{
		super("Peer Positions");
		panel.add(headline);
		panel.add(master);
		master.setEnabled(false);
		for (int i = 0 ; i < slaveNames.length ; i++)
		{
			slaveNames[i] = new JLabel("Slave "+(i+1)+" : ( - , - )",JLabel.CENTER);
			panel.add(slaveNames[i]);
			slaveNames[i].setEnabled(false);
		}
		
		this.add(panel);
		this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		this.setVisible(true);
	}
	
	
	public void setPeerPosition(Point p, byte peerNum)
	{
		if (peerNum>0)
		{
			slaveNames[peerNum-1].setText("Slave "+peerNum+" : ("+p.x+","+p.y+")");
			slaveNames[peerNum-1].setEnabled(true);
		}
		else 
		{
			master.setText(" MASTER : ("+p.x+","+p.y+")");
			master.setEnabled(true);
		}
		panel.repaint();
	}
	
	public void resetMaster()
	{
		master.setText(" MASTER  : ( - , - )");
		master.setEnabled(false);
		panel.repaint();
	}
	
	public void resetSlaves()
	{
		for (int i = 0 ; i < slaveNames.length ; i++)
		{
			slaveNames[i].setText("Slave "+(i+1)+" : ( - , - )");
			slaveNames[i].setEnabled(false);
			panel.repaint();
		}
	}
	
	public void delSlaves(byte p)
	{
		for (int i = p-1 ; i < slaveNames.length ; i++)
		{
			slaveNames[i].setText("Slave "+(i+1)+" : ( - , - )");
			slaveNames[i].setEnabled(false);
			panel.repaint();
		}
	}
	
}