import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JRadioButton;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.*;

public class SetRangesFrame extends JFrame implements ActionListener,ItemListener
{
	JPanel panel = new JPanel();
	JPanel radioButtonsPanels[] = new JPanel[8];
	JPanel buttonPanel = new JPanel();
	
	GridLayout grid = new GridLayout(9,2);
	FlowLayout flow = new FlowLayout();
	
	JLabel headline1 = new JLabel("Peer #",JLabel.CENTER);
	JLabel headline2 = new JLabel("Range (m)",JLabel.CENTER);
	JLabel master = new JLabel(" MASTER ",JLabel.CENTER);
	JLabel slaveLabels[] = new JLabel[7];
	
	JRadioButton radioButtons[] = new JRadioButton[16];
	
	ButtonGroup radioGroups[] = new ButtonGroup[8];
	
	JButton doneButton = new JButton("Done");
	
	int rangesMatrix[] = {10,10,10,10,10,10,10,10};
	MapPanel mapPanel;
		
	
	public SetRangesFrame(byte slaveNum , MapPanel mP)
	{
		super("Set Ranges");
		panel.setLayout(grid);
		panel.add(headline1);
		panel.add(headline2);
		
		mapPanel = mP;
					
		for (int i = 0 ; i < radioButtons.length/2 ; i++)
		{
			radioGroups[i] = new ButtonGroup();
			radioButtonsPanels[i] = new JPanel(flow);
			radioButtons[i] = new JRadioButton("10");
			radioButtons[i].addItemListener(this);			
			radioButtons[i+(radioButtons.length/2)] = new JRadioButton("100");
			radioButtons[i+(radioButtons.length/2)].addItemListener(this);
			radioGroups[i].add(radioButtons[i]);
			radioGroups[i].add(radioButtons[i+(radioButtons.length/2)]);
			radioButtonsPanels[i].add(radioButtons[i]);
			radioButtonsPanels[i].add(radioButtons[i+(radioButtons.length/2)]);
			if (mapPanel.rangesMatrix[i]==100) radioButtons[i].setSelected(true);
				else radioButtons[i+(radioButtons.length/2)].setSelected(true);
		}
		
		panel.add(master);
		panel.add(radioButtonsPanels[0]);		
		
		for (int i = 0 ; i < slaveLabels.length ; i++)
		{
			slaveLabels[i] = new JLabel("Slave "+(i+1),JLabel.CENTER);
			panel.add(slaveLabels[i]);
			panel.add(radioButtonsPanels[i+1]);
		}
		
		for (int i = slaveNum ; i < slaveLabels.length ; i++)
		{
			slaveLabels[i].setEnabled(false);
			radioButtons[i+1].setEnabled(false);
			radioButtons[(i+(radioButtons.length/2))+1].setEnabled(false);			
		}
			
		
		buttonPanel.setLayout(flow);
		doneButton.addActionListener(this);
		buttonPanel.add(doneButton);
		
		add(panel,BorderLayout.CENTER);
		add(buttonPanel,BorderLayout.SOUTH);
	}
	
	public void actionPerformed (ActionEvent ae)
	{
		String command = ae.getActionCommand();
		if (command == "Done")
		{ 
			for (int i=0 ; i<rangesMatrix.length; i++)
				System.out.print(rangesMatrix[i]+",");
			mapPanel.copyRangesMatrix(rangesMatrix);
			mapPanel.repaint();		
			this.dispose();
		}
	}
	
	public void itemStateChanged(ItemEvent ie)
	{
		for ( int i = 0 ; i < radioButtons.length ; i++)
		{
			if (ie.getSource() == radioButtons[i])
			{
				System.out.println("it came from radiobutton :"+i);
				if (ie.getStateChange() == ItemEvent.SELECTED)
				{
					if (i < 8) rangesMatrix[i] = 100;
						else rangesMatrix[i-8] = 200;
				}
			}
		} 
		
	}
}