import java.util.Calendar;
import javax.swing.JPanel;
import javax.swing.JLabel;
import java.awt.FlowLayout;

public class SimClock extends JPanel implements Runnable
{
	
	JLabel simTime = new JLabel("Simulation Time :") ;
	JLabel simClock = new JLabel("hh:mm:ss:ms") ;
	
	FlowLayout flow = new FlowLayout();
	
	Calendar now ;
	
	Storage store;
	
	int day,
		hour,
		minute,
		second,
		millisec,
		simDay,
		simHour,
		simMinute,
		simSecond,
		simMillisec ;
		
	boolean running = false ;
	boolean paused = false;
	
	double startedAt,
		   current,
		   runsFor,
		   wasPausedFor,
		   wasPausedAt;	
		
	String returnString = "" ;
	
	public SimClock(Storage st)
	{
				
		store = st;
		this.setLayout(flow);
		this.add(simTime);
		this.add(simClock);
		this.setVisible(true);	
		
		wasPausedFor = 0 ;		
		
	}
	
	public void run()
	{
		
		//System.out.println("\n\n"+simDay+":"+simHour+":"+simMinute+":"+simSecond+":"+simMillisec+"\n\n");
		//System.out.println(Thread.currentThread().getName());
		
		try
		{
			while(running)
			{
				
				if (paused) 
				{
					
				}
				else
				{
					Thread.sleep(5);
					now = Calendar.getInstance();
					simDay = now.get(Calendar.DAY_OF_YEAR);
					simHour = now.get(Calendar.HOUR_OF_DAY);
					simMinute = now.get(Calendar.MINUTE);
					simSecond = now.get(Calendar.SECOND);
					simMillisec = now.get(Calendar.MILLISECOND);
			
					simClock.setText(calculateTime());
					this.repaint();
			
				}
				
				
			}
		}
		
		catch (InterruptedException exception)
		{
			exception.printStackTrace();
		}
				
	} //end of run
	
	public String calculateTime()
	{
		
		current = (simDay*86400000)+(simHour*3600000)+(simMinute*60000)+(simSecond*1000)+simMillisec;
		runsFor = (current - startedAt - wasPausedFor);
		int tempDay =(int) runsFor / 86400000;		
		int tempHour = (int) runsFor % 86400000;
		int tempMinute = (int) tempHour % 3600000;
		int tempSecond = (int) tempMinute % 60000;
		int tempMillisec = (int) tempSecond % 1000;
		
		/*
		int tempHour = ((simHour-hour) >=0 ? ((simHour-hour)+((simDay-day)*24)) : (24+(simHour-hour)+(simDay-day)*24));
		int tempMinute = ((simMinute-minute) >=0 ? (simMinute-minute) : (60+(simMinute-minute))); 
		int tempSecond = ((simSecond-second) >=0 ? (simSecond-second) : (60+(simSecond-second)));
		int tempMillisec = ((simMillisec-millisec) >=0 ? (simMillisec-millisec) : (1000+(simMillisec-millisec)));*/
		returnString = "" ;
		
		
		if ((tempHour/3600000)<10) returnString +="0";
		returnString += ((tempHour/3600000)+":");
		if ((tempMinute/60000)<10) returnString +="0";
		returnString += ((tempMinute/60000)+":");
		if ((tempSecond/1000)<10) returnString +="0";
		returnString += ((tempSecond/1000)+":");
		if ((tempMillisec)<10) returnString +="00";
		else if ((tempMillisec<100) && (tempMillisec>=10)) returnString +="0";
		returnString += (tempMillisec);
		return returnString;
	
	}
	
	public void toggleRunning()
	{
		running = !running;
		store.setEndTime(returnString);
	}
	
	public void startClock()
	{
		now = Calendar.getInstance();
		day = now.get(Calendar.DAY_OF_YEAR);
		hour = now.get(Calendar.HOUR_OF_DAY);
		minute = now.get(Calendar.MINUTE);
		second = now.get(Calendar.SECOND);
		millisec = now.get(Calendar.MILLISECOND);
		
		store.setStartTime(String.format("%2d:%2d:%2d:%3d",hour,minute,second,millisec));
		
		startedAt = (day*86400000)+(hour*3600000)+(minute*60000)+(second*1000)+millisec;
		
		//System.out.println("ok~!!!!!!\n\n"+day+":"+hour+":"+minute+":"+second+":"+millisec+"\n\n"+"started at:"+startedAt+"\nDay :"+((startedAt/31536000000)));
		
		running = true;
		
	}
	
	public int getCurrentMinute()
	{
		current = (simDay*86400000)+(simHour*3600000)+(simMinute*60000)+(simSecond*1000)+simMillisec;
		//System.out.println("current:"+current+"\tstarted at"+startedAt+"\twasPausedFor:"+wasPausedFor);
		runsFor = (current - startedAt - wasPausedFor);
		int tempDay =(int) runsFor / 86400000;		
		int tempHour = (int) runsFor % 86400000;
		int tempMinute = (int) tempHour % 3600000;
		
		
		return tempMinute/60000;
	}
	
	public void pause()
	{
		now = Calendar.getInstance();
		day = now.get(Calendar.DAY_OF_YEAR);
		hour = now.get(Calendar.HOUR_OF_DAY);
		minute = now.get(Calendar.MINUTE);
		second = now.get(Calendar.SECOND);
		millisec = now.get(Calendar.MILLISECOND);
					
		wasPausedAt = (day*86400000)+(hour*3600000)+(minute*60000)+(second*1000)+millisec;	
		
		paused = true;
	}
	
	
	public void resume()
	{
		now = Calendar.getInstance();
		day = now.get(Calendar.DAY_OF_YEAR);
		hour = now.get(Calendar.HOUR_OF_DAY);
		minute = now.get(Calendar.MINUTE);
		second = now.get(Calendar.SECOND);
		millisec = now.get(Calendar.MILLISECOND);
		
		wasPausedFor += ((day*86400000)+(hour*3600000)+(minute*60000)+(second*1000)+millisec - wasPausedAt) ;		
		
		paused = false;
	}
	
	public void setSpecific(int m)
	{
		simClock.setText(String.format("%2d:%2d:%2d:%3d",(int)(m/60),(m%60),0,0));
		this.repaint();
	}
	
	public int getTotalSecs()
	{
		return (int)runsFor/1000;
	}
	
} //end of class