import java.awt.Graphics;
import javax.swing.JPanel;
import java.awt.Color;
import java.awt.Point;
import java.awt.Font;
import java.lang.Math;


public class SimMap extends JPanel 
{
	
	
	Point peerPositions[] = new Point[8];
	
	boolean drawPacket[] = new boolean[8];
	
	char pID[] = {'M','1','2','3','4','5','6','5'};
	
	String[] statusText = {"Stand By","Inquiring","Inquiry Scan","Paging","Page Scan","Connected","Hold","Park","Sniff"};
	
	Color[] colors = {Color.RED,Color.YELLOW,Color.YELLOW,Color.YELLOW,Color.YELLOW,Color.YELLOW,Color.YELLOW,Color.YELLOW};
	
	int status[] = new int[8];
		
		
	int rangesMatrix[] = new int[8];
	
	float degrees[] = new float[91];
	
	boolean sR = false;
	boolean showStatus = true;
	
	Storage store;
	
	
	public SimMap(Storage sto)
	{
		store = sto;
		
		peerPositions = store.getPositions();
		rangesMatrix = store.getRanges();
		
		for (int i = 0 ; i < status.length ; i++)
		{
			status[i]=0;
		}
		for (int i = 0 ; i < drawPacket.length ; i++)
		{
			drawPacket[i]=false;
		}
		/*for (int i = 0 ; i < degrees.length ; i++)
		{
			degrees[i] = Math.sin(Math.toRadians(i));
		}*/
	}
	
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);
		
		int width = getWidth();
		int height = getHeight();
		
		this.setBackground(Color.WHITE);
		g.setColor(Color.BLUE);
		
		for (int i=0;i<=width;i+=15)
		{
			g.drawLine(i,0,i,height);
		}
		
		for (int x=0;x<=height;x+=15)
		{
			g.drawLine(0,x,width,x);
		}
		
		for (int i = 0 ; i < peerPositions.length ; i++	)
		{
			if ((peerPositions[i].x != 0) && (peerPositions[i].y != 0))
			{
				g.setColor(colors[i]);				
				g.fillOval(peerPositions[i].x-10,peerPositions[i].y-10,20,20);				
				g.setColor(Color.BLACK);
				g.drawOval(peerPositions[i].x-10,peerPositions[i].y-10,19,19);
				g.setFont(new Font(null,0,12));				
				g.drawChars(pID,i,1,(peerPositions[i].x-4),(peerPositions[i].y+5));				
				g.setFont(new Font(null,1,14));
				if (showStatus)	g.drawString(statusText[status[i]],(peerPositions[i].x+8),(peerPositions[i].y-8));
				//System.out.println("Drew at :"+(peerPositions[i].x)+","+peerPositions[i].y);
			}
		}
		
		for (int i = 0 ; i < peerPositions.length ; i++	)
		{
			if ((sR) && (peerPositions[i].x != 0) && (peerPositions[i].y != 0))
			{
				g.drawOval(peerPositions[i].x-(rangesMatrix[i]*4),peerPositions[i].y-(rangesMatrix[i]*4),(2*rangesMatrix[i]),(2*rangesMatrix[i]));
			}
		}
		
		for (int i = 0 ; i < drawPacket.length ; i++	)
		{	
			if (drawPacket[i])
			{
				
				/*	int distanceX = peerPositions[i].x-peerPositions[0].x;
					int distanceY = peerPositions[i].y-peerPositions[0].y;
					g.drawString("distance x:"+distanceX+"\tdistance Y :"+distanceY,0,i*30);
					if (distanceX>0)
					{
						int index=0;
						for (int x=distanceX ; x>0 ; x-=5)
						{	
							index++;
							if (distanceY>0)
							{
								int distYdec = distanceY-5;
								int distXdev = distanceX/5;
								if (distYdec<1) distYdec=1;
								if (distXdev<1) distXdev=1;
								g.setColor(Color.BLACK);
								g.draw3DRect(peerPositions[0].x+x, peerPositions[0].y+distanceY, 5,5,true);
								g.setColor(Color.GREEN);	
								g.fill3DRect(peerPositions[0].x+x, peerPositions[0].y+distanceY, 5,5,true);
								if (distXdev>distYdec)
								{
									if ((index % (int)((distXdev)/(distYdec)))==0) distanceY-=1;
								}
								else
								{
									if ((index % (int)((distYdec)/(distXdev)))==0) distanceY-=1;
								}
																
							}
							else
							{
								int distYdec = distanceY-5;
								int distXdev = distanceX/5;
								if (distYdec<1) distYdec=1;
								if (distXdev<1) distXdev=1;
								g.setColor(Color.BLACK);
								g.draw3DRect(peerPositions[0].x+x, peerPositions[0].y+distanceY, 5,5,true);
								g.setColor(Color.GREEN);	
								g.fill3DRect(peerPositions[0].x+x, peerPositions[0].y+distanceY, 5,5,true);
								if ((index % ((distXdev)/(distYdec)))==0) distanceY+=1;	
							}														
						}						
					}
					else 
					{
						for (int x=distanceX ; x < 0 ; x+=5)
						{	
							if (distanceY>0)
							{
								g.setColor(Color.BLACK);
								g.draw3DRect(peerPositions[0].x+x, peerPositions[0].y+distanceY, 5,5,true);
								g.setColor(Color.GREEN);	
								g.fill3DRect(peerPositions[0].x+x, peerPositions[0].y+distanceY, 5,5,true);
								distanceY-=5;
							}
							else
							{
								g.setColor(Color.BLACK);
								g.draw3DRect(peerPositions[0].x+x, peerPositions[0].y+distanceY, 5,5,true);
								g.setColor(Color.GREEN);	
								g.fill3DRect(peerPositions[0].x+x, peerPositions[0].y+distanceY, 5,5,true);
								distanceY+=5;
							}																		
						}	
					}
				*/	
				g.setColor(Color.ORANGE);
				g.drawOval(peerPositions[i].x-15,peerPositions[i].y-15,30,30);
				g.drawOval(peerPositions[i].x-20,peerPositions[i].y-20,40,40);
				g.drawOval(peerPositions[i].x-25,peerPositions[i].y-25,50,50);
				g.drawOval(peerPositions[i].x-30,peerPositions[i].y-30,60,60);
				g.setColor(Color.BLACK);
				drawPacket[i]  = false ;
									
			}
		}
		
	} //end of paintComponent
	
	
	
	public void setColor(Color color,int peerNum)
	{
		colors[peerNum] = color;
	}
	
	public Point getPeerPosition(int i )	
	{
		return peerPositions[i];
	}
	
	public synchronized void transmission(int p)
	{
		drawPacket[p]  = true ;
		this.repaint();
	}
	
	public void setEndOfTransmission(int p)
	{
		drawPacket[p]  = false ;
	}
	
	public void setShowStatus(boolean show)
	{
		showStatus = show;
		this.repaint();
	}
	
}