import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;


public class SimParams extends JFrame implements ActionListener
{
	
	JPanel centerPanel = new JPanel(new BorderLayout());
	JPanel questionsPanel = new JPanel(new GridLayout(4,1,0,8));
	JPanel textFieldsPanel = new JPanel(new GridLayout(4,1,0,8));
	JPanel buttonsPanel = new JPanel(new FlowLayout());
	JPanel[] param = new JPanel[4]; 
	
	JTextField[] field = new JTextField[4];
	
	JLabel pleaseLabel= new JLabel("Please fill-in  the \nfollowing parameters :",JLabel.CENTER);
	JLabel rLabel = new JLabel("1.Network traffic load :");
	JLabel zLabel = new JLabel("2.Packet generation probability :");
	JLabel bLabel = new JLabel("3.Average burst lenght :");
	JLabel qLabel = new JLabel("4.Buffer Size :");
	JLabel[] units = new JLabel[4];
	
	String initFields[] = {"100","100","100","10000"};
	String initUnits[] = {"%","%","packets","packets"};
	
	JButton proceedButton = new JButton("Done");
	JButton defaultsButton = new JButton("Defaults");
	
	float r,z,b;
	
	int q;
	
	Screen screen;
	Storage store;
	
	public SimParams(Screen scr, Storage st)
	{
		super("Simulation Parameters");
		screen = scr;
		store = st;
		for (int i = 0 ; i < param.length ; i++)
		{
			param[i] = new JPanel(new GridLayout(1,2,3,0));
			field[i] = new JTextField(2);
			units[i] = new JLabel(initUnits[i],JLabel.CENTER);
			param[i].add(field[i]);
			param[i].add(units[i]);			
		}
		proceedButton.addActionListener(this);
		defaultsButton.addActionListener(this);
		this.add(pleaseLabel,BorderLayout.NORTH);
		questionsPanel.add(rLabel);		
		questionsPanel.add(zLabel);
		questionsPanel.add(bLabel);
		questionsPanel.add(qLabel);
		textFieldsPanel.add(param[0]);
		textFieldsPanel.add(param[1]);		
		textFieldsPanel.add(param[2]);		
		textFieldsPanel.add(param[3]);
		centerPanel.add(questionsPanel,BorderLayout.CENTER);
		centerPanel.add(textFieldsPanel,BorderLayout.EAST);
		buttonsPanel.add(defaultsButton);
		buttonsPanel.add(proceedButton);
		this.add(centerPanel,BorderLayout.CENTER);
		this.add(buttonsPanel,BorderLayout.SOUTH);
		this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		this.setSize(300,180);
		this.setLocation(400,300);
		this.setVisible(true);
		
		
	}
	
	public void actionPerformed (ActionEvent ae)
	{
		if (ae.getSource()==proceedButton)
		{
			try
			{					
				r = Float.parseFloat(field[0].getText());
				z = Float.parseFloat(field[1].getText());
				b = Float.parseFloat(field[2].getText());
				q = Integer.parseInt(field[3].getText());
				
			}
					
			catch (NullPointerException npe)
			{
				JOptionPane.showMessageDialog(null,"Please enter only possitive integer values!","Input Error!",JOptionPane.ERROR_MESSAGE);		
			}
			
			catch (NumberFormatException nfe)
			{
				JOptionPane.showMessageDialog(null,"Please enter only possitive integer values!","Input Error!",JOptionPane.ERROR_MESSAGE);
			}
			
			if ((r<=0) || (z<=0) || (b<=0) || (q<=0)) JOptionPane.showMessageDialog(null,"Please enter only possitive integer values!","Input Error!",JOptionPane.ERROR_MESSAGE);
			else
			{
				store.setR(r);
				store.setZ(z);
				store.setB(b);
				store.setQ(q);
				screen.setConfigured();
				screen.toFront();
				screen.setEnabled(true);
				screen.toFront();
				this.dispose();
		
			}
		}
		
		else if (ae.getSource()==defaultsButton)
		{
			for (int i = 0 ; i < param.length ; i++)
			{
				field[i].setText(initFields[i]);
			}
		}
		
	}
	
}