import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.lang.SecurityException;


public class Statistics extends JFrame implements ActionListener
{
	
	Storage store;
	Screen screen;
	
	int throughput = 0;	
	int delay = 0;
	int load = 0;
	int peerNum = 0;
	
	String startedAt,endedAt;
	
	JPanel informationPanel = new JPanel(new GridLayout(5,2));
	JPanel buttonsPanel = new JPanel(new FlowLayout());
	
	JLabel title = new JLabel("Simulation Results",JLabel.CENTER);
	JLabel throughputTitle = new JLabel("Average Throughput :",JLabel.LEFT);
	JLabel delayTitle = new JLabel("Average Delay :",JLabel.LEFT);
	JLabel peersTitle = new JLabel("Participating Peers :",JLabel.LEFT);
	JLabel startedAtTitle = new JLabel("Started At :",JLabel.LEFT);
	JLabel endedAtTitle = new JLabel("Duration :",JLabel.LEFT);
	
	JButton closeButton = new JButton("Close");
	JButton saveToFileButton = new JButton("Save to File");
	
	Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	
	File file = new File("data.txt");
		
	public Statistics(Screen scr, Storage st)
	{
		
		
		
		super("Statistics");
		store = st;
		screen = scr;
		load = (int)(store.getR()*100);
		this.add(title,BorderLayout.NORTH);
		delay = store.getDelay();
		throughput = store.getThroughput();
		peerNum = store.getPeerNum();
		JLabel startedAtLabel = new JLabel(store.getStartTime());		
		informationPanel.add(startedAtTitle);
		informationPanel.add(startedAtLabel);
		JLabel endedAtLabel = new JLabel(store.getEndTime());
		informationPanel.add(endedAtTitle);
		informationPanel.add(endedAtLabel);	
		informationPanel.add(throughputTitle);
		JLabel throughputLabel  = new JLabel(""+throughput+" bits/sec");
		informationPanel.add(throughputLabel);
		informationPanel.add(delayTitle);
		JLabel delayLabel  = new JLabel(""+delay+" ms");
		informationPanel.add(delayLabel);
		JLabel peerNumLabel = new JLabel(""+(peerNum+1));
		informationPanel.add(peersTitle);
		informationPanel.add(peerNumLabel);			
		this.add(informationPanel,BorderLayout.CENTER);
		closeButton.addActionListener(this);
		saveToFileButton.addActionListener(this);
		buttonsPanel.add(saveToFileButton);
		buttonsPanel.add(closeButton);
		this.add(buttonsPanel,BorderLayout.SOUTH);
		this.setSize(300,200);
		this.setLocation(screenSize.width/2-this.WIDTH/2,screenSize.height/2-this.HEIGHT/2);
		this.setResizable(false);
		this.setVisible(true);
	}
	
	public void actionPerformed( ActionEvent ae)
	{
		if (ae.getSource() == closeButton)
		{
			this.dispose();
			screen.setEnabled(true);
			screen.toFront();
		}
		
		else if (ae.getSource() == saveToFileButton)
		{
			if (!file.exists())
			{
				try
				{
					Formatter output = new Formatter("data.txt");
					output.close();
					BufferedWriter out = new BufferedWriter(new FileWriter("data.txt", true));
					out.write(String.format("%12s %12s %5s %17s %5s %11s"," Started At ","  Duration  ","Load","   Throughput    "," Delay ","Total Peers"));
					out.newLine();
					out.write(String.format("------------ ------------ ----- ----------------- ------- -----------"));
					out.newLine();
					out.close();
									
				}
				catch (SecurityException se)
				{
					JOptionPane.showMessageDialog(null,"You don't have write access to file data.txt","Saving Error!",JOptionPane.ERROR_MESSAGE);
				}
				catch (FileNotFoundException fnfe)
				{
					JOptionPane.showMessageDialog(null,"File data.txt could not be created","Saving Error!",JOptionPane.ERROR_MESSAGE);
				}
				catch (IOException e) 
				{
					
				}			
			}
			
			try
			{
				BufferedWriter out = new BufferedWriter(new FileWriter("data.txt", true));
				int totalPeers = peerNum +1;
				out.write(String.format("%12s %12s %4d%% %9dbits/sec %5dms %11d",store.getStartTime(),store.getEndTime(),load,throughput,delay,totalPeers));
				out.newLine();
				out.close();
			}
			catch (IOException e) 
			{
				
			}
	
			saveToFileButton.setEnabled(false);
		}
	}
}